#ifndef ACCESS_H
#define ACCESS_H

#include "../feat_skill/feat_skill.h"
#include "../race/race.h"
#include "../chars/chars.h"
#include <set>
using namespace std;

/// Permessi di accesso, uso, ascolto...
class Access{
	private:
		/// Elenco feature obbligatorie
		set<Feat> yes_feat;
		/// Elenco feature vietate
		set<Feat> no_feat;
		/// Elenco skill con quantit minima
		set<Skill> yes_skill;
		/// Elenco skill con quantit massima
		set<Skill> no_skill;
		/// Elenco razze consentite
		set<Race> yes_race;
		/// Elenco razze vietate
		set<Race> no_race;
		/// Elenco appartenenze consentite
		set<Ownership> yes_own;
		/// Elenco appartenenze vietate
		set<Ownership> no_own;
	public:
		/// controlla permessi di personaggio giocante
		bool allowed(Character* pg);
};

/**
 * \example access_test.cc
 */

#endif
