#ifndef CHARS_H
#define CHARS_H

#include <string>
#include <set>
#include "../race/race.h"
#include "../tempset/tempset.h"
#include "../feat_skill/feat_skill.h"
using namespace std;

/// Personaggio generico
class Character{
	private:
		/// Nome ed identificativo del personaggio
		string name;
		/// Breve descrizione
		string desc;
		/// Razza
		Race r;
		/// Classi di appartenenza (es. chierico, eterosessuale, juventino, ...)
		TempSet<Ownership> owns;
		/// Lista Features
		TempSet<Feat> fe;
		/// Lista Skill
		TempSet<Skill> sk;
	public:
		/// Restituisce il nome
		string getName() {return name;}
		/// Restituisce la descrizione
		string getDesc() {return desc;}
		/// Restituisce la razza
		string getRace() {return r;}
		/// Restituisce il set delle classi di appartenenza
		TempSet<Ownership>* getOwns() {return &owns;}
		/// Restituisce la lista delle features
		TempSet<Feat>* getFeats() {return &fe;}
		/// Restituisce la lista delle skill
		TempSet<Skill>* getSkills() {return &sk;}
};

/// Personaggio giocante
class PlayC : public Character{
};

/**
 * \example chars_test.cc
 */

#endif
