#ifndef EFFECTS_H
#define EFFECTS_H

#include <map>
#include <set>
#include "../feat_skill/feat_skill.h"
using namespace std;

/// Classe Effects: effetti nel possesso e uso di oggetti
/**
 * La classe Effects contiene le modifiche ai punti feriti,
 * le features da attivare e togliere, le variazioni alle skill,
 * (con eventuali durate per feat attive e variaz. skill) che comportano
 * il possesso o l'uso (wear, cast) di un'oggetto.
 */
class Effects{
	private:
		/// mappa features da attivare con eventuale durata in secondi
		map<Feat,int> f_on;
		/// mappa skills con eventuale durata in secondi
		map<Skill,int> sk_var;
		/// set features da disattivare
		set<Feat> f_off;
	public:
		/// restituisce la mappa features/durata
		const map<Feat,int>& get_feats() {return f_on;}
		/// restituisce la mappa skill/durata
	        const map<Skill,int>& get_skills() {return sk_var;}
		/// restituisce le features da disattivare (usato solo dalle magie)
		const set<Feat>& get_feats_off();
};

/**
 * \example effects_test.cc
 */

#endif
