#ifndef MAGIC_H
#define MAGIC_H

/**
 * \file magic.h
 * \brief Magie
 *
 * magic.h contiene le dichiarazioni riguardanti le magie
 */

#include "../effects/effects.h"
#include "../chars/chars.h"
class Caster;

/**
 * \enum area
 * \brief Area di una magia
 */
enum area {
	PERSONAL,	///< Ha effetto su chi la lancia
	TARGET,		///< Ha effetto su un bersaglio
	LOCATION	///< Ha effetto su tutti i personaggi di una location
};

/// Classe magia, descrive un incantesimo da lanciare
class Magic{
	private:
		/// nome magia
		string name;
		/// descrizione magia
		string desc;
		/// effetti della magia quando lanciata
		Effects fx;
		/// area della magia
		area ar;		
	public:
		/// costruttore banale
		Magic() {}
		/// costruttore
		Magic(string n, string d, Effects ef, area a): name(n), desc(d), fx(ef), ar(a) {}
		/// costruttore per con solo nome per permettere la ricerca in map
		Magic(string n): name(n) {}
		/// lancio della magia
		string cast(Caster*, Character* = NULL) const {return "ciao";}
                /// Ordinamento in base al solo nome
                friend bool operator<(const Magic& sx, const Magic& dx){
			sx.name<dx.name;
                }
};

/**
 * \example magic_test.cc
 */
#endif
